#!/usr/bin/perl -w

#
# Frederic Rodrigo (c) 2005 <f.rodrigo free.fr> http://f.rodrigo.free.fr/
# This script convert a plain SVG into weather icons chunk
# In order to run you need Inkscape and ImageMagik
#

use strict;

my $input_svg = "r-weather-icon.svg";
my $dir = "r-weather-icon";

my @table = (
[ '36','32','34','30','28','39', '?', '?', '?', '?','37', '?', '20' ],
[  '?','31','33','29','27','45', '?', '?','46','47', '?', '?', '19' ],
[ 'na', '?', '?', '?','26', '?','40', '5','13','35', '4', '9', '21' ],
[  '?','23', '?', '?', '?', '?', '1', '?','43', '?', '?', '?', '22' ],
[  '?','25', '?', '?', '?', '?','10', '7', '?', '?', '?', '8',  '?' ]
);

my %link = (
 3, 35,
38,  4,
41, 13,
42, 13,
44, 30,
 0, 35,
17, 35,
14, 13,
15, 13,
16, 13,
11, 40,
12, 40,
18, 40,
 6, 40,
24, 23,
 2,  1
);


sub crop
{
    my( $input_png, $size, $out_dir ) = @_;
    my $y = 0;
    foreach( @table )
    {
	my @line = @$_;
        my $x = 0;
	foreach( @line )
        {
    	    if( $_ ne '?' )
	    {
		my $out = "$out_dir/$_.png";
    		my $x_ = $x*$size;
		my $y_ = $y*$size;
		print "    CROP $input_png TO $out (${size}x$size+$x_+$y_)\n";
		`convert $input_png -crop ${size}x$size+$x_+$y_ $out`;
	    }
	    $x++;
	}
	$y++;
    }
}

sub make_link
{
    my( $out_dir ) = @_;
    while( my ($src,$dest) = each(%link) )
    {
	my $out_src  = "$out_dir/$src.png";
	my $out_dest = "$dest.png";
	print "    LINK $out_dest FROM $out_src\n";
	`ln -s $out_dest $out_src`;
    }
}

sub check_link
{
    # done check over link, dump error on link over link
    while( my ($src,$dest) = each(%link) )
    {
	if( $link{$dest} )
	{
	    print "Error: link over link: $src -> $dest -> %link{$dest}\n";
	    exit 0;
	}
    }
}

sub build
{
    my ( $sub_dir, $size ) = @_;
    
    print "BUILD $sub_dir AT $size\n";

    mkdir( "$dir/$sub_dir" );
    `rm -f $dir/$sub_dir/*`;

    print "    CONVERT $input_svg TO $input_svg.$size.png\n";
    my $w = 13 * $size;
#    `inkscape -z -e $input_svg.$size.png -w $w $input_svg 2> /dev/null`;

    crop( "$input_svg.$size.png", $size, "$dir/$sub_dir" );
    make_link( "$dir/$sub_dir" );
}

check_link();

mkdir( $dir );
build( "large_icons", 120 );
build( "small_icons", 28 );
`cp README $dir`
